####################################################################################################
# PDM Container Image with Python 3.12 Available
#
# PDM itself is installed in the system environment, which for UBI9 is Python 3.9.
# However, this image makes a Python 3.12 interpreter available as an additional option,
# helps PDM-managed Python 3.12 projects.
####################################################################################################
FROM registry.access.redhat.com/ubi9/ubi:9.3-1610@sha256:66233eebd72bb5baa25190d4f55e1dc3fff3a9b77186c1f91a0abdb274452072
USER root
ENV DNF_OPTS="--setopt=install_weak_deps=False --setopt=tsflags=nodocs" \
    PDM_VERSION=2.18.1 \
    SETUPTOOLS_VERSION=74.1.1 \
    WHEEL_VERSION=0.44.0
RUN dnf update -y && \
    dnf install -y ${DNF_OPTS} \
                python3-pip \
                python3.12 \
                python3.12-pip \
&&  dnf clean all -y
RUN /usr/bin/pip3 install --upgrade pip --no-cache-dir \
 && /usr/bin/pip3 install --no-cache-dir \
                          "setuptools==${SETUPTOOLS_VERSION}" \
                          "wheel==${WHEEL_VERSION}" \
                          "pdm==${PDM_VERSION}"
